CON

    MPaddr1 = $A6  'i2c address of baro sensor
     MPaddr2 = $A4  'i2c address of baro sensor

OBJ
   i2c_cmd      : "i2c_cmd"

VAR
   long _220uS
   long _40uS
   long MP_DATA_00, MP_DATA_01, MP_DATA_02, MP_DATA_03, MP_DATA_04, MP_DATA_05,MP_DATA_06, MP_DATA_07, MP_DATA_08, MP_DATA_09 , MP_DATA_0a , MP_DATA_0b , MP_DATA_0c , MP_DATA_0d , MP_DATA_0e, MP_DATA_0f  
   long MP_DATA_10, MP_DATA_11, MP_DATA_12, MP_DATA_13, MP_DATA_14, MP_DATA_15,MP_DATA_16, MP_DATA_17, MP_DATA_18, MP_DATA_19 , MP_DATA_1a , MP_DATA_1b , MP_DATA_1c , MP_DATA_1d , MP_DATA_1e, MP_DATA_1f  
   long MP_DATA_20, MP_DATA_21, MP_DATA_22, MP_DATA_23, MP_DATA_24, MP_DATA_25,MP_DATA_26, MP_DATA_27, MP_DATA_28, MP_DATA_29 , MP_DATA_2a , MP_DATA_2b , MP_DATA_2c , MP_DATA_2d , MP_DATA_2e, MP_DATA_2f  
   long MP_DATA_30, MP_DATA_31, MP_DATA_32, MP_DATA_33, MP_DATA_34, MP_DATA_35,MP_DATA_36, MP_DATA_37, MP_DATA_38, MP_DATA_39 , MP_DATA_3a , MP_DATA_3b , MP_DATA_3c , MP_DATA_3d , MP_DATA_3e, MP_DATA_3f  
   long MP_DATA_40, MP_DATA_41, MP_DATA_42, MP_DATA_43, MP_DATA_44, MP_DATA_45,MP_DATA_46, MP_DATA_47, MP_DATA_48, MP_DATA_49 , MP_DATA_4a , MP_DATA_4b , MP_DATA_4c , MP_DATA_4d , MP_DATA_4e, MP_DATA_4f  
   
   byte i2cSCL, i2cSDA, x
   
PUB init(_scl, _sda)
   i2cSCL := _scl
   i2cSDA := _sda
   i2c_cmd.Init(i2cSDA, i2cSCL, false)
   _220uS := clkfreq / 100_000 * 22 
   _40uS := clkfreq / 100_000 * 4 

PUB readMP | data[6]

   i2c_cmd.writeLocation(MPaddr1, $40, $00, 8, 8)
   waitcnt(_220uS+cnt)
   i2c_cmd.i2cStart
   i2c_cmd.i2cWrite(MPaddr1, 8)
   i2c_cmd.i2cWrite(0,8)
   i2c_cmd.i2cStop
   waitcnt(_220uS+cnt)
   i2c_cmd.i2cStart
   i2c_cmd.i2cWrite(MPaddr1|1, 8)
   
  repeat x from 0 to $FE
   data[x] := i2c_cmd.i2cRead(0)
   
 data[x+1] := i2c_cmd.i2cRead(1) 

  MP_DATA_00 := data[ $f0]
  MP_DATA_01 := data[ $f1]
  MP_DATA_02 := data[ $f2]
  MP_DATA_03 := data[ $f3]
  MP_DATA_04 := data[ $f4]
  MP_DATA_05 := data[ $f5]
  MP_DATA_06 := data[ $f6]
  MP_DATA_07 := data[ $f7]
  MP_DATA_08 := data[ $f8]
  MP_DATA_09 := data[ $f9]
  MP_DATA_0a := data[ $fA]
  MP_DATA_0b := data[ $fB]
  MP_DATA_0c := data[ $fC]
  MP_DATA_0d := data[ $fD]
  MP_DATA_0e := data[ $fE]
  MP_DATA_0f := data[ $fF]



  i2c_cmd.i2cStop

PUB enMotionPlus
   ''enables Motion Plus controller (writing $04 to Address $FE in the $A6 address space)
   ''this must be done once, which will remap the Motion Plus to the standard extension $A4 address space
   i2c_cmd.writeLocation(MPaddr1, $FE, $04, 8, 8)
   waitcnt(_220uS+cnt)
PUB disableMotionPlus
   ''enables Motion Plus controller (writing $04 to Address $FE in the $A6 address space)
   ''this must be done once, which will remap the Motion Plus to the standard extension $A4 address space
   i2c_cmd.writeLocation(MPaddr1, $F0, $55, 8, 8)
   waitcnt(_220uS+cnt)
    i2c_cmd.writeLocation(MPaddr1, $FB, $0, 8, 8)
   waitcnt(_220uS+cnt)
 
PUB MP_00
   return MP_DATA_00

PUB MP_01
   return MP_DATA_01

PUB MP_02
   return MP_DATA_02

PUB MP_03
   return MP_DATA_03

PUB MP_04
   return MP_DATA_04

PUB MP_05
   return MP_DATA_05

PUB MP_06
   return MP_DATA_06

PUB MP_07
   return MP_DATA_07

PUB MP_08
   return MP_DATA_08

PUB MP_09
   return MP_DATA_09

PUB MP_0a
   return MP_DATA_0a

PUB MP_0b
   return MP_DATA_0b

PUB MP_0c
   return MP_DATA_0c

PUB MP_0d
   return MP_DATA_0d

PUB MP_0e
   return MP_DATA_0e
   
PUB MP_0f
   return MP_DATA_0f


PUB MP_10
   return MP_DATA_10

PUB MP_11
   return MP_DATA_11

PUB MP_12
   return MP_DATA_12

PUB MP_13
   return MP_DATA_13

PUB MP_14
   return MP_DATA_14

PUB MP_15
   return MP_DATA_15

PUB MP_16
   return MP_DATA_16

PUB MP_17
   return MP_DATA_17

PUB MP_18
   return MP_DATA_18

PUB MP_19
   return MP_DATA_19

PUB MP_1a
   return MP_DATA_1a

PUB MP_1b
   return MP_DATA_1b

PUB MP_1c
   return MP_DATA_1c

PUB MP_1d
   return MP_DATA_1d

PUB MP_1e
   return MP_DATA_1e
   
PUB MP_1f
   return MP_DATA_1f


PUB MP_20
   return MP_DATA_20

PUB MP_21
   return MP_DATA_21

PUB MP_22
   return MP_DATA_22

PUB MP_23
   return MP_DATA_23

PUB MP_24
   return MP_DATA_24

PUB MP_25
   return MP_DATA_25

PUB MP_26
   return MP_DATA_26

PUB MP_27
   return MP_DATA_27

PUB MP_28
   return MP_DATA_28

PUB MP_29
   return MP_DATA_29

PUB MP_2a
   return MP_DATA_2a

PUB MP_2b
   return MP_DATA_2b

PUB MP_2c
   return MP_DATA_2c

PUB MP_2d
   return MP_DATA_2d

PUB MP_2e
   return MP_DATA_2e
   
PUB MP_2f
   return MP_DATA_0f


PUB MP_30
   return MP_DATA_30

PUB MP_31
   return MP_DATA_31

PUB MP_32
   return MP_DATA_32

PUB MP_33
   return MP_DATA_33

PUB MP_34
   return MP_DATA_34

PUB MP_35
   return MP_DATA_35

PUB MP_36
   return MP_DATA_36

PUB MP_37
   return MP_DATA_37

PUB MP_38
   return MP_DATA_38

PUB MP_39
   return MP_DATA_39

PUB MP_3a
   return MP_DATA_3a

PUB MP_3b
   return MP_DATA_3b

PUB MP_3c
   return MP_DATA_3c

PUB MP_3d
   return MP_DATA_3d

PUB MP_3e
   return MP_DATA_3e
   
PUB MP_3f
   return MP_DATA_3f


PUB MP_40
   return MP_DATA_40

PUB MP_41
   return MP_DATA_41

PUB MP_42
   return MP_DATA_42

PUB MP_43
   return MP_DATA_43

PUB MP_44
   return MP_DATA_44

PUB MP_45
   return MP_DATA_45

PUB MP_46
   return MP_DATA_46

PUB MP_47
   return MP_DATA_47

PUB MP_48
   return MP_DATA_48

PUB MP_49
   return MP_DATA_49

PUB MP_4a
   return MP_DATA_4a

PUB MP_4b
   return MP_DATA_4b

PUB MP_4c
   return MP_DATA_4c

PUB MP_4d
   return MP_DATA_4d

PUB MP_4e
   return MP_DATA_4e
   
PUB MP_4f
   return MP_DATA_4f